import usb.core
import usb.util
import sys
import time

#input is a 5 byte list
#bmRequesttype - 0x21 - HID
#bmrequest - 0x09 - SET_REPORT
#wValue - Report Type and Rport ID - 0x02 0x00
#wIndex - Interface - 0
#msg - list of values

#active = 0 or 255 (off or on) pulse_speed = 0-7 (7 is fastest pulse)
def LWZ_SBA (active1,active2,active3,active4,pulse_speed):

        #find device
        dev = usb.core.find(idVendor=0xfafa, idProduct=0x00f0)
        if dev is None:
                raise ValueError('LedWiz device not found')
                # sys.exit

        #claim device
        if dev.is_kernel_driver_active(0) is True:
                dev.detach_kernel_driver(0)
                usb.util.claim_interface(dev,0)

        #activate device
        if not dev.get_active_configuration():
                dev.set_configuration(1)


        #send message to device
        lz_array = [active1, active2, active3, active4,pulse_speed]
        msg = [64]+lz_array+[0,0]
        dev.ctrl_transfer(0x21, 0x09, 0x0200, 0, msg)

        #release device
        usb.util.release_interface(dev,0)



def LWZ_PBA (color1,color2,color3,color4,color5,color6,color7,color8):
        #find device
        dev = usb.core.find(idVendor=0xfafa, idProduct=0x00f0)
        if dev is None:
                raise ValueError('LedWiz device not found')
                # sys.exit

        #claim device
        if dev.is_kernel_driver_active(0) is True:
                dev.detach_kernel_driver(0)
                usb.util.claim_interface(dev,0)

        #activate device
        if not dev.get_active_configuration():
                dev.set_configuration(1)

        #send message to device
        msg = [color1,color2,color3,color4,color5,color6,color7,color8]
        dev.ctrl_transfer(0x21, 0x09, 0x0200, 0, msg)

        #release device
        usb.util.release_interface(dev,0)


#activates all 4 banks of 8 outputs
LWZ_SBA(255,255,255,255,7)

#sends to each bank of 8 outputs
LWZ_PBA(48,0,0,48,0,0,48,0)
LWZ_PBA(0,48,0,0,48,0,0,48)
LWZ_PBA(0,0,48,0,0,48,0,0)
LWZ_PBA(48,0,0,48,0,0,0,0)


time.sleep(2)
LWZ_SBA(0,0,0,0,0)
time.sleep(2)

LWZ_SBA(255,255,255,255,7)

LWZ_PBA(0,48,0,0,48,0,0,48)
LWZ_PBA(0,0,48,0,0,48,0,0)
LWZ_PBA(48,0,0,48,0,0,48,0)
LWZ_PBA(0,48,0,0,48,0,0,0)

time.sleep(2)
LWZ_SBA(0,0,0,0,0)
time.sleep(2)


LWZ_SBA(255,255,255,255,7)

LWZ_PBA(0,0,48,0,0,48,0,0)
LWZ_PBA(48,0,0,48,0,0,48,0)
LWZ_PBA(0,48,0,0,48,0,0,48)
LWZ_PBA(0,0,48,0,0,48,0,0)